VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEditUDL2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'   ========================================================================
'   Edit UDL (Universal Data Link) Version 2.3
'   This is a class that lets you create and edit UDL files.
'   These are files that contain ADO connection information to data sources.
'   You can create files then use the output as a connection string in
'   your applications. Or you can save the files which,
'   when opened, will display the connection information
'   in the Microsoft Data Link Properties dialog.
'
'   Scott Woods 1/02/2001
'
'   Refernces Required
'
'   Microsoft Scripting Runtime
'   Microsoft OLE DB Service Component 1.0 Type Library
'   Microsoft ActiveX Data Objects 2.1 or Higher
'
'
' ************ SAMPLE CODE 1 ************
' ' Passing a pre-defined connection string to a new Udl file
' Dim obj As clsEditUDL2
'
' Set obj = New clsEditUDL2
''
' ' Prompt UDL Dialog Box and Save the information
' obj.NewUdl "C:\WINNT\Profiles\qswsf\Desktop\cpm3.udl", True, _
'            "Provider=SQLOLEDB.1;Integrated Security=SSPI;" & _
'            "Persist Security Info=False;" & _
'            "Initial Catalog=MISDataWarehouse;Data Source=QACRSOLGAS002"
' Set obj = nothing
'
' ************ SAMPLE CODE 2 ************
' ' Create or Open the UDL file using the UdlExist method to
' ' validate if the UDL already exists.
'
'Dim objUdl         As clsEditUDL2
'Dim strFileName    As String
'
'strFileName = "C:\TestMe.udl"
'
'Set objUdl = New clsEditUDL2
'
'If objUdl.UdlExist(strFileName) Then
'    objUdl.OpenUdl strFileName, True
'Else
'    objUdl.NewUdl strFileName, True
'End If
'
'Set objUdl = Nothing

'   ========================================================================

Private m_strProviderTag        As String
Private mstrProvider            As String
Private mstrIntegratedSecurity  As String
Private mstrUserId              As String
Private mstrInitialCatalog      As String
Private mstrDataSource          As String
Private mstrPersistSecurityInfo As String
Private mstrMode                As String
Private mstrConnectTimeout      As String
Private mstrInitialFileName     As String
Private mstrUdlFilePath         As String
Private mstrExtendedProperties  As String
Private mstrCurrentLanguage     As String
Private mstrNetworkAddress      As String
Private mstrNetworkLibrary      As String
Private mstrApplicationName     As String
Private mstrConnectionString    As String
Private mstrNewConnectionString As String

Private m_objFSO                As Scripting.FileSystemObject
Private mcolPropertyValue       As Collection
Private mcolPropertyName        As Collection

Private Const C_OLEDB_DATA_ONE    As String = "[oledb]"
Private Const C_OLEDB_DATA_TWO    As String = "; Everything after this line is an OLE DB initstring"

Public Property Get Provider() As String
Provider = mstrProvider
End Property
Friend Property Let Provider(ByVal str_Provider As String)
mstrProvider = str_Provider
End Property
Public Property Get IntegratedSecurity() As String
IntegratedSecurity = mstrIntegratedSecurity
End Property
Friend Property Let IntegratedSecurity(ByVal str_IntegratedSecurity As String)
mstrIntegratedSecurity = str_IntegratedSecurity
End Property
Public Property Get PersistSecurityInfo() As String
PersistSecurityInfo = mstrPersistSecurityInfo
End Property
Friend Property Let PersistSecurityInfo(ByVal str_PersistSecurityInfo As String)
mstrPersistSecurityInfo = str_PersistSecurityInfo
End Property
Public Property Get UserId() As String
UserId = mstrUserId
End Property
Friend Property Let UserId(ByVal str_UserId As String)
mstrUserId = str_UserId
End Property
Public Property Get InitialCatalog() As String
InitialCatalog = mstrInitialCatalog
End Property
Friend Property Let InitialCatalog(ByVal str_InitialCatalog As String)
mstrInitialCatalog = str_InitialCatalog
End Property
Public Property Get DataSource() As String
DataSource = mstrDataSource
End Property
Friend Property Let DataSource(ByVal str_DataSource As String)
mstrDataSource = str_DataSource
End Property
Public Property Get InitialFileName() As String
InitialFileName = mstrInitialFileName
End Property
Friend Property Let InitialFileName(ByVal str_InitialFileName As String)
mstrInitialFileName = str_InitialFileName
End Property
Public Property Get Mode() As String
Mode = mstrMode
End Property
Friend Property Let Mode(ByVal str_Mode As String)
mstrMode = str_Mode
End Property
Public Property Get ConnectTimeout() As String
ConnectTimeout = mstrConnectTimeout
End Property
Friend Property Let ConnectTimeout(str_ConnectTimeout As String)
mstrConnectTimeout = str_ConnectTimeout
End Property
Public Property Get Path() As String
    Path = mstrUdlFilePath
End Property
Friend Property Let Path(ByVal str_UDLFilePath As String)
    mstrUdlFilePath = str_UDLFilePath
End Property
Public Property Get ExtendedProperties() As String
ExtendedProperties = mstrExtendedProperties
End Property
Friend Property Let ExtendedProperties(ByVal str_ExtendedProperties As String)
mstrExtendedProperties = str_ExtendedProperties
End Property
Public Property Get CurrentLanguage() As String
CurrentLanguage = mstrCurrentLanguage
End Property
Friend Property Let CurrentLanguage(ByVal str_CurrentLanguage As String)
mstrCurrentLanguage = str_CurrentLanguage
End Property
Public Property Get NetWorkAddress() As String
NetWorkAddress = mstrNetworkAddress
End Property
Friend Property Let NetWorkAddress(ByVal str_NetWorkAddress As String)
mstrNetworkAddress = str_NetWorkAddress
End Property
Public Property Get NetworkLibrary() As String
 NetworkLibrary = mstrNetworkLibrary
End Property
Friend Property Let NetworkLibrary(ByVal str_NetworkLibrary As String)
mstrNetworkLibrary = str_NetworkLibrary
End Property
Public Property Get ApplicationName() As String
ApplicationName = mstrApplicationName
End Property
Friend Property Let ApplicationName(ByVal str_ApplicationName As String)
mstrApplicationName = ApplicationName
End Property
Public Property Get ConnectionString() As String
ConnectionString = mstrConnectionString
End Property
Friend Property Let ConnectionString(ByVal str_ConnectionString As String)
mstrConnectionString = str_ConnectionString
End Property

Public Property Get PropertyValue(ByVal var_Index As Variant) As String
    On Error Resume Next
    PropertyValue = mcolPropertyValue(var_Index)
End Property

Public Property Get PropertyName(ByVal var_Index As Variant) As String
 On Error Resume Next
 PropertyName = mcolPropertyName(var_Index)
End Property

Public Property Get PropertyCount() As Integer
    PropertyCount = mcolPropertyValue.Count
End Property

Private Sub Class_Initialize()
    Set m_objFSO = New Scripting.FileSystemObject
    Set mcolPropertyValue = New Collection
    Set mcolPropertyName = New Collection
    m_strProviderTag = "P" & Chr(0) & _
                       "r" & Chr(0) & _
                       "o" & Chr(0) & _
                       "v" & Chr(0) & _
                       "i" & Chr(0) & _
                       "d" & Chr(0) & _
                       "e" & Chr(0) & _
                       "r"
End Sub
Private Sub Class_Terminate()
    If Not m_objFSO Is Nothing Then Set m_objFSO = Nothing
    If Not mcolPropertyValue Is Nothing Then Set mcolPropertyValue = Nothing
    If Not mcolPropertyName Is Nothing Then Set mcolPropertyName = Nothing
End Sub

Public Function OpenUdl(ByVal str_UDLFilename As String, _
                        Optional ByVal bln_PromptDialogBox As Boolean = True, _
                        Optional ByRef Form_hWnd As Long = 0) As String

On Error GoTo OpenUdlErr

'   ========================================================================
' AIM   :   To open an existing udl connection string File for Edit.
'
'
'       Arugments
'                   : str_UdlFileName       -   Name of the Udl file
'                   : bln_PromptDialogBox   -   Force the Udl Dialog Box to Appear
'
'                   : Form_hWnd             -   Used to bind the UDL Dialog box
'                                               to the form - Optional = 0 means
'                                               no form is used.
'
'   ========================================================================

Dim objOpenUdl              As MSDASC.DataLinks
Dim cnnOpenUdl              As ADODB.Connection
Dim strRead                 As String
Dim strWrite                As String
Dim strNewProvider          As String
Dim strConnectionString     As String
Dim intFind                 As Integer


' Make sure that the udl file exists
If m_objFSO.FileExists(str_UDLFilename) Then
    ' If so, then open the file out as binary Read
    Open str_UDLFilename For Binary Access Read As #1
         'Set Buffer Space
         strRead = Space$(3000)
         Get #1, 1, strRead
    Close #1
    ' Locate the provider tag
    intFind = InStr(1, strRead, m_strProviderTag, vbBinaryCompare)
    If intFind > 0 Then
       ' If found, then convert unicode value back to normal string
       strConnectionString = Replace(Mid(strRead, intFind), Chr(0), "", 1)
        ' Did the User request a dialog box ?
        If bln_PromptDialogBox Then
            ' Yes, then open the dialog box and populate
            ' with ConnectionString Results
            Set objOpenUdl = New MSDASC.DataLinks
            Set cnnOpenUdl = New ADODB.Connection
            cnnOpenUdl.ConnectionString = strConnectionString
            If objOpenUdl.PromptEdit(cnnOpenUdl) Then
                ' Get the Modified Results, if any
                strConnectionString = cnnOpenUdl.ConnectionString
               ' Convert the ConnectionString back to UniCode
               strNewProvider = Left(strRead, intFind - 1) & _
                                StrConv(strConnectionString, vbUnicode)
                          
               ' We need to delete the old file
               ' because it upsets the original format
               ' @@@ Still needs to be reviewed
               UdlDelete (str_UDLFilename)
                ' Recreate the UDL file with the same name and
                ' with any modifications.
                Open str_UDLFilename For Binary Access Write As #2
                    strWrite = strNewProvider
                    Put #2, 1, strWrite
                Close #2
            End If
        End If
    End If
    ' Set the connection string property
     mstrConnectionString = strConnectionString
     mstrUdlFilePath = str_UDLFilename
     OpenUdl = mstrConnectionString
     SplitConnectionString
End If

OpenUdlExit:
    ' Release Objects
    If Not objOpenUdl Is Nothing Then Set objOpenUdl = Nothing
    If Not objOpenUdl Is Nothing Then Set objOpenUdl = Nothing
    
    Exit Function

OpenUdlErr:
    MsgBox Err.Number & " :" & Err.Description
    Resume OpenUdlExit
End Function

Private Sub SplitConnectionString()

On Error GoTo SplitConnectionStringErr

' =========================================================================
'   AIM : To split the Property names and values into an array
'         and to populate the Properties of the Class
' =========================================================================

Dim astrSplit()         As String
Dim intLoop             As Integer
Dim strPropertyName     As String
Dim strPropertyValue    As String


If mstrConnectionString <> vbNullString Then
    
    ' Remove any old properties from the collection
    RemoveProperty
    
    astrSplit = Split(mstrConnectionString, ";")
    mcolPropertyValue.Add mstrConnectionString, "Connection String"
    mcolPropertyName.Add "Connection String", "Connection String"
    For intLoop = 0 To UBound(astrSplit)
        
        ' Split the properties
        strPropertyName = vbNullString
        strPropertyName = Left(astrSplit(intLoop), InStr(1, astrSplit(intLoop), "=", vbTextCompare) - 1)
        If strPropertyName <> vbNullString Then
            strPropertyValue = Mid(astrSplit(intLoop), InStr(1, astrSplit(intLoop), "=", vbTextCompare) + 1)
            mcolPropertyValue.Add strPropertyValue, strPropertyName
            mcolPropertyName.Add strPropertyName, strPropertyName
        End If
        
        ' Populate the Properites of the class
        Select Case strPropertyName
        
        Case "Provider"
            mstrProvider = strPropertyValue
        
        Case "Persist Security Info"
            mstrPersistSecurityInfo = strPropertyValue
        
        Case "User ID"
            mstrUserId = strPropertyValue
        
        Case "Data Source"
            mstrDataSource = strPropertyValue
        
        Case "Mode"
            mstrMode = strPropertyValue
        
        Case "Connect Timeout"
            mstrConnectTimeout = strPropertyValue
        
        Case "Initial Catalog"
            mstrInitialCatalog = strPropertyValue
        
        Case "Integrated Security"
            mstrIntegratedSecurity = strPropertyValue
        
        Case "Initial File Name"
            mstrInitialFileName = strPropertyValue
        
        Case "Extended Properties"
            mstrExtendedProperties = strPropertyValue
        
        Case "Current Language"
            mstrCurrentLanguage = strPropertyValue
        
        Case "Network Library"
            mstrNetworkLibrary = strPropertyValue
        
        Case "Network Address"
            mstrNetworkAddress = strPropertyValue
        
        Case "Application Name"
            mstrApplicationName = strPropertyValue
            
        End Select
       
    Next intLoop

End If

SplitConnectionStringExit:
    
    Exit Sub

SplitConnectionStringErr:
    MsgBox Err.Number & " :" & Err.Description
    Resume SplitConnectionStringExit
End Sub

Private Sub RemoveProperty()
' =========================================================================
'   AIM :  To remove all the property values and names from both
'          collection objects.
' =========================================================================

On Error Resume Next

Dim intLoop As Integer

If mcolPropertyValue.Count > 0 Then
    For intLoop = mcolPropertyValue.Count To 1 Step -1
         mcolPropertyValue.Remove intLoop
         mcolPropertyName.Remove intLoop
    Next intLoop
End If
    
End Sub

Public Function GetProperty(ByVal str_UDLFilename As String, _
                            ByVal str_PropertyName As String) As Variant

On Error GoTo GetPropertyErr

' =========================================================================
' AIM       : To obatin a single Property value from a UDL file.
'
' Arugments : str_UDLFilename   -   Name of the UDL file to access
'           : str_PropertyName  -   Name of the property to be obtained
'
'
'            If the Property Name doesn't exist, a null string is returned
'
' =========================================================================

'
Dim intLoop As Integer

OpenUdl str_UDLFilename, False

If PropertyCount > 0 Then
       For intLoop = 1 To PropertyCount
           If UCase(PropertyName(intLoop)) = UCase(str_PropertyName) Then
               GetProperty = PropertyValue(intLoop)
           End If
       Next intLoop
End If

GetPropertyExit:
    
    Exit Function

GetPropertyErr:
    MsgBox Err.Number & " :" & Err.Description
    Resume GetPropertyExit
End Function

Public Function NewUdl(ByVal str_UDLFilename As String, _
                       Optional ByVal bln_PromptDialogBox As Boolean = True, _
                       Optional ByVal str_ConnectionString As String = vbNullString, _
                       Optional ByRef Form_hWnd As Long = 0) As String

On Error GoTo NewUdlErr

'   ========================================================================
' AIM   :   To create a new udl file.
'
'
'       Arugments
'                   : str_UdlFileName       -   Name of the Udl file
'                   : bln_PromptDialogBox   -   Force the Udl Dialog Box to Appear
'
'                   : str_ConnectionString  -   Optional; Can pass a full connection
'                                               string from an ADO Connetion String
'                                               Optional = Vbnullstring
'                                               If the Dialog Box is shown when a
'                                               connection string is passed, the class
'                                               will populate the dialog box with
'                                               the str_ConnectionString
'
'
'                   : Form_hWnd             -   Optional; Used to bind the UDL
'                                               Dialog box to the form - Optional = 0 means
'                                               no form is used.
'
'   ========================================================================

Dim objNewUdl              As MSDASC.DataLinks
Dim cnnNewUdl              As ADODB.Connection
Dim strWrite               As String

If bln_PromptDialogBox Then
    ' Yes, then open the dialog box and populate
    ' with ConnectionString Results
    Set objNewUdl = New MSDASC.DataLinks
    Set cnnNewUdl = New ADODB.Connection
    cnnNewUdl.ConnectionString = str_ConnectionString
    If objNewUdl.PromptEdit(cnnNewUdl) Then
        ' Get the Modified Results, if any
        str_ConnectionString = cnnNewUdl.ConnectionString
        strWrite = "" & StrConv(C_OLEDB_DATA_ONE & vbCrLf, vbUnicode) & _
                          StrConv(C_OLEDB_DATA_TWO & vbCrLf, vbUnicode) & _
                          StrConv(str_ConnectionString, vbUnicode)
        ' Create the UDL file with the udl filename and
        ' with any modifications.
        Open str_UDLFilename For Binary Access Write As #2
            Put #2, 1, strWrite
        Close #2
    End If
End If



' Set the connection string property
 mstrConnectionString = str_ConnectionString
 mstrUdlFilePath = str_UDLFilename
 NewUdl = mstrConnectionString
 SplitConnectionString
 
NewUdlExit:
    ' Release Objects
    If Not objNewUdl Is Nothing Then Set objNewUdl = Nothing
    If Not objNewUdl Is Nothing Then Set objNewUdl = Nothing
    
    Exit Function

NewUdlErr:
    MsgBox Err.Number & " :" & Err.Description
    Resume NewUdlExit
End Function

Public Function UdlExist(ByVal str_UDLFilename As String) As Boolean
    UdlExist = m_objFSO.FileExists(str_UDLFilename)
End Function
Public Sub UdlDelete(ByVal str_UDLFilename As String)
    If UdlExist(str_UDLFilename) Then
        m_objFSO.DeleteFile str_UDLFilename, True
    End If
End Sub
